from model.DateUtils import DateUtils
from model.DataBaseUtils import MysqlUtils, CkUtils
from datetime import datetime, timedelta, timezone
import time
import logging

du = DateUtils()
db = MysqlUtils()
ck = CkUtils()


def insert_order_data_game_one(ymd):
    # TODO: channel_id 有问题，不可以使用app_id游戏id
    logging.info('订单数据格式转换 ，开始 ')
    datatime_ymd = datetime.strptime(ymd, '%Y-%m-%d').astimezone(timezone(timedelta(hours=8))).timetuple()
    timestamp_ymd = time.mktime(datatime_ymd)
    tomorrow_ymd = (datetime.strptime(ymd, '%Y-%m-%d').astimezone(timezone(timedelta(hours=8))) + timedelta(
        days=1)).timetuple()
    timestamp_tom = time.mktime(tomorrow_ymd)

    sql = f'''
    select DATE(FROM_UNIXTIME(a.create_time)),'',payway as order_type,c.wx_name,a.app_id ,
    concat('sdk_one_',f.id) as user_id,
    DATE_FORMAT(FROM_UNIXTIME(a.create_time), '%Y-%m-%d %H:%i:%s') as order_time,
    DATE_FORMAT(FROM_UNIXTIME(f.create_time), '%Y-%m-%d %H:%i:%s') as reg_time,
    a.amount ,ifnull(d.name,''),a.order_id ,a.status 
    from db_mp.h_pay a 
    left join 
    (select b.agent_id,b.advertiser_conf_id  from 
        (select agent_id,max(update_time) as update_time  
        from db_mp.mp_conf_agent mmc 
        group by agent_id ) a
        left join db_mp.mp_conf_agent b on  a.agent_id=b.agent_id 
        and a.update_time = b.update_time ) b on  a.agent_id =b.agent_id 
    left join db_mp.mp_mp_conf c on b.advertiser_conf_id = c.id 
    left join db_mp.h_game d on a.app_id = d.id 
    left join db_mp.h_member f on a.mem_id = f.id
    where c.`type` in (6,7)
    and a.create_time<={timestamp_tom} and a.create_time>={timestamp_ymd}
    '''
    # print(sql)
    list_ = db.db_mp.get_data_list(sql)
    data_list = []
    for _ in list_:
        data_list.append(tuple(_))
    sql = """replace into ods_order(date,stage,platform,channel,channel_id,user_id,
            order_time,
            reg_time,
            amount,from_novel,order_id,status) values(%s,%s,%s,%s,%s,%s,%s,%s,%s,%s,%s,%s) """

    db.quchen_text.executeMany(sql, data_list)
    logging.info('订单数据格式转换 ，结束 ')


def insert_order_data_ck():
    logging.info('订单数据格式转换 ，开始 ')

    sql = f'''
        insert into game_data.order
        (date,stage,platform,channel,channel_id,user_id,
                order_time,
                reg_time,
                amount,from_novel,order_id,status)
        select toDate(FROM_UNIXTIME(a.create_time)),'',
        payway as order_type,
        c.wx_name,a.app_id ,f.id as user_id,
        FROM_UNIXTIME(a.create_time) as order_time,
        FROM_UNIXTIME(f.create_time) as reg_time,
        a.amount ,ifnull(d.name,''),a.order_id ,a.status 
        from GameDataSum.h_pay_sum a 
        left join 
        (select b.agent_id agent_id,b.advertiser_conf_id advertiser_conf_id  from 
            (select agent_id,max(update_time) as update_time  
            from GameDataSum.mp_conf_agent mmc 
            group by agent_id ) a
            left join GameDataSum.mp_conf_agent b on  a.agent_id=b.agent_id 
            and a.update_time = b.update_time ) b on  a.agent_id =b.agent_id 
        left join GameDataSum.mp_mp_conf c on b.advertiser_conf_id = c.id 
        left join (select toUInt32(id) id,name from GameDataSum.h_game) d
                on a.app_id = d.id
        left join (select toUInt32(id) id,create_time from GameDataSum.h_member) f
        on a.mem_id = f.id
        where c.`type` in (6,7)
        '''
    print(sql)
    ck.execute(sql)

    final_sql = '''OPTIMIZE table game_data.order final '''
    ck.execute(final_sql)

    logging.info('订单数据格式转换 ，结束 ')


def insert_order_data_ck_gamedatasum(ymd):
    logging.info('订单数据格式转换 ，开始 ')
    datatime_ymd = datetime.strptime(ymd, '%Y-%m-%d').astimezone(timezone(timedelta(hours=8))).timetuple()
    timestamp_ymd = time.mktime(datatime_ymd)
    tomorrow_ymd = (datetime.strptime(ymd, '%Y-%m-%d').astimezone(timezone(timedelta(hours=8))) + timedelta(
        days=1)).timetuple()
    timestamp_tom = time.mktime(tomorrow_ymd)

    sql = f'''
        insert into game_data.order
        (date,stage,platform,channel,channel_id,user_id,
                order_time,
                reg_time,
                amount,from_novel,order_id,status)
        select toDate(FROM_UNIXTIME(a.create_time)),'',
        payway as order_type,
        c.wx_name,a.app_id ,f.id as user_id,
        FROM_UNIXTIME(a.create_time) as order_time,
        FROM_UNIXTIME(f.create_time) as reg_time,
        a.amount ,ifnull(d.name,''),a.order_id ,a.status 
       from GameDataSum.h_pay_sum a 
        left join 
        (select b.agent_id agent_id,b.advertiser_conf_id advertiser_conf_id  from 
            (select agent_id,max(update_time) as update_time  
            from GameDataSum.mp_conf_agent_sum mmc 
            group by agent_id ) a
            left join GameDataSum.mp_conf_agent_sum b on  a.agent_id=b.agent_id 
            and a.update_time = b.update_time ) b on  a.agent_id =b.agent_id 
        left join GameDataSum.mp_mp_conf_sum c on b.advertiser_conf_id = c.id 
        left join GameDataSum.h_game_sum d on a.app_id = d.id
        left join  GameDataSum.h_member_sum f on a.mem_id = f.id
        where c.`type` in (6,7)
            and a.create_time<={timestamp_tom} and a.create_time>={timestamp_ymd}

        '''
    print(sql)
    ck.execute(sql)

    final_sql = '''OPTIMIZE table game_data.order final '''
    ck.execute(final_sql)

    logging.info('订单数据格式转换 ，结束 ')


def insert_order_data_hourly():
    insert_order_data_ck_gamedatasum(du.getNow())


def insert_order_data_daily():
    for i in du.getDateLists(du.get_n_days(-10), du.get_n_days(0)):
        print(i)
        insert_order_data_ck_gamedatasum(i)


if __name__ == '__main__':
    # insert_order_data_daily()
    # insert_order_data_ck()
    insert_order_data_hourly()
