import logging
import time
from logging import handlers
from app.etl.dw.dw_channel_daily import dw_channel
from app.etl.sync_to_ck_task import order_sync_ck
from model.DateUtils import DateUtils
from app.api_data.platform_order.order_data_change import insert_order_data


def order_update():
    logging.info('start update order')
    insert_order_data(du.getNow())
    order_sync_ck(du.getNow())
    dw_channel()
    logging.info('end update order')


du = DateUtils()
if __name__ == '__main__':
    logging.basicConfig(
        handlers=[
            logging.handlers.RotatingFileHandler('./log/dw_order_update_min.log',
                                                 maxBytes=10 * 1024 * 1024,
                                                 backupCount=5,
                                                 encoding='utf-8')
            , logging.StreamHandler()  # 供输出使用
        ],
        level=logging.INFO,
        format="%(asctime)s - %(levelname)s %(filename)s %(funcName)s %(lineno)s - %(message)s"
    )
    order_update()
